#include "frepla2.h"
#include "lcdbseta.c"



#byte puerto_a=0x05
#byte puerto_b=0x06
#byte TRISA=0x85
#byte TRISB=0x86
#byte TMR0=1
#byte OPTION_REG=0x81
#byte INTE=0x0B
#byte STATUS=3


#byte T1CON=0x10
#byte TMR1L=0x0E
#byte TMR1H=0x0F
#byte PIR1=0x0C


unsigned char numero;
unsigned char numero2;
unsigned char numero3;
unsigned int16 retardo;
unsigned int16 retardo2;
//unsigned char contador2;

unsigned char error1;

// Se pone para que no modifique el ensamblador
#OPT 0


void frecu9c()
{
   unsigned char z;
      puerto_b=puerto_b | 128;
      z=T1CON ;   //| 1;   //memoriza T1CON
      T1CON=z & 254; // pone a cero TMR1ON Desactiva contador
      PIR1=PIR1&254; //Borra rebase
      error1=0;      //Borra error
      TMR1L=0;
      TMR1H=0;
      T1CON=z & 255; // pone a uno TMR1ON activa contador
      delay_seta(retardo);
      delay_seta(retardo2);
      T1CON=z & 254; // pone a cero TMR1ON Desactiva contador
      puerto_b=puerto_b & 127;
     
      numero=TMR1L;
      numero2=TMR1H;
      numero3=0;
      if(PIR1&1) error1=1;
      PIR1=PIR1&254; //Borra rebase
}



void main()
{
 //unsigned int z;
 float xx;
 unsigned char escala,multipli;
 
     puerto_b=0;
     puerto_a=0;
   
//Puerto B como salida, el RB6 entrada de frecuencia
     TRISB=0x40;
//Puerto A como entrada 
     TRISA=0xff;
        
   lcd_ini_seta();   
   lcd_cls();
   
      lcd_gotoxy(1,1);
      Lcd_putc ("\fFRECUENCIMETRO\nSETA43");
      delay_seta(60000);
      Lcd_putc ("\f");
      lcd_gotoxy(1,1);
      Lcd_putc ("\fxsetaseta@gmail.com");      
      delay_seta(60000);
      Lcd_putc ("\f");

      T1CON=0b00000111;
      escala=3;
 
 while(true)
 {  
      if(bit_test(puerto_a,4)==1)
         {
            escala++;
            if(escala>3)escala=0;
            lcd_cls();
            lcd_gotoxy(1,1);
            Lcd_putc ("Cambiando escala ");
            while(bit_test(puerto_a,4)==1);
            lcd_cls();
         }
      lcd_gotoxy(1,1);   
      switch(escala)
             {
               case 0:
//                  Lcd_putc ("Escala0");
                  Lcd_putc ("0-65500 Hz       ");
                  retardo=50000;
                  retardo2=50000;
                  T1CON=0b00000111;
                  multipli=1;
                  break;
               case 1:
//                Lcd_putc ("Escala1");
                  Lcd_putc ("0-655 KHz        ");                  
                  retardo=5000;
                  retardo2=5000;
                  T1CON=0b00000111;
                  multipli=10;
                  break;
               case 2:
//                Lcd_putc ("Escala2");
                  Lcd_putc ("0-6.5 MHZ        ");
                  retardo=3997;
                  retardo2=4000;
                  T1CON=0b00110111;
                  multipli=1;
                  break;
               case 3:
//                Lcd_putc ("Escala3");
                  Lcd_putc ("0-65 MHz         ");
                  retardo=397;
                  retardo2=400;
                  T1CON=0b00110111;
                  multipli=1;
                  break;                  
            }             
      
      lcd_gotoxy(16,1);
      lcd_putc("*");
      delay_seta(10000);
      frecu9c();
      lcd_gotoxy(16,1);
      lcd_putc(" ");
      
/*      lcd_gotoxy(9,1);
      printf(lcd_putc,"%u ",numero2);
      printf(lcd_putc,"%u  ",numero);
      
*/   
      xx=(numero+numero2*256+numero3*65536)*multipli;
                lcd_gotoxy(1,2);
      if(error1==1)
         {
          lcd_putc(" Error escala   ");
         }
         else
         {
      
          switch(escala)      
              {              
               case 2:
                  xx=xx/10;
                  printf(lcd_putc,"%9.1f ",xx);
                  lcd_putc("KHz");
                  break;
               case 3:
                  printf(lcd_putc,"%9.0f ",xx);
                  lcd_putc("KHz");
                  break;  
               default:
                  printf(lcd_putc,"%9.0f ",xx); 
                  lcd_putc("Hz ");              
            }       
         }
         
      lcd_gotoxy(18,1);      
      delay_seta(10000);
      
 
 }
 
 
 
 
}
